.686p
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      '???',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>
ps      PAINTSTRUCT	    <>
hDC     HDC     ?
hMemDC  HDC     ?
hBackDC HDC     ?
szImage db      '.\sph.bmp',0
hBmp    HBITMAP     ?
hBmp2   HBITMAP     ?
xform   XFORM   <0,0,0,0,-1.0,-1.0>
onezero     dd      1.0
MyTimer dd      ?
rect    RECT    <> 
Angle   dd      0.0
oneeighty   dd      180.0    
radAngle    dd      0.0
pi      dd      3.1416
onerad    dd      0.017453
.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke	GetStockObject,BLACK_BRUSH
    mov	wc.hbrBackground,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
	.elseif	uMsg==WM_CREATE
		mov		edi,lParam
		.if	[edi.CREATESTRUCT].hWndParent==NULL
                INVOKE  GetClientRect,hWnd,addr rect
                invoke  LoadImage,hInstance,addr szImage,IMAGE_BITMAP,NULL,NULL,LR_LOADFROMFILE+LR_DEFAULTSIZE
                mov     hBmp,eax
                invoke  GetDC,hWnd
                mov     hDC,eax
                invoke  CreateCompatibleDC,hDC
                mov     hMemDC,eax
                invoke  CreateCompatibleDC,hDC
                mov     hBackDC,eax
                invoke  SetMapMode,hMemDC,MM_ANISOTROPIC
                invoke  SetGraphicsMode,hMemDC,GM_ADVANCED
                invoke  CreateCompatibleBitmap,hDC,1000,1000
                invoke  SelectObject,hMemDC,eax
                invoke  DeleteObject,eax
                invoke  BitBlt,hMemDC,0,0,128,128,hMemDC,0,0,PATPAINT
                invoke  SelectObject,hBackDC,hBmp
                invoke  DeleteObject,eax
                invoke  ReleaseDC,hWnd,hDC
		.endif	        	
    .elseif uMsg==WM_PAINT
        invoke  BeginPaint,hWnd,addr ps
        invoke  BitBlt,ps.hdc,0,0,1000,1000,hBackDC,0,0,SRCCOPY
        invoke  EndPaint,hWnd,addr ps

    .elseif uMsg==WM_CHAR
                invoke  SetTimer,hWnd,MyTimer,20,addr WndProc
        
    .elseif uMsg==WM_TIMER
        
        fld     Angle
        fcos    
        fstp    xform.eM11
        fld     Angle
        fsin            
        ;fchs
        fstp    xform.eM21
        fld     Angle
        fsin
        fstp    xform.eM12
        fld     Angle
        fcos
        fstp    xform.eM22
        mov     xform.ex,1
        mov     xform.ey,1
        fld1;     onezero
        fadd    Angle
        fstp    Angle
        invoke  BitBlt,hMemDC,0,0,10000,10000,hBackDC,0,0,SRCCOPY
        invoke  BitBlt,hBackDC,0,0,128,128,hBackDC,0,0,PATPAINT
        invoke  SetWorldTransform,hMemDC,addr xform         
        invoke  BitBlt,hBackDC,0,0,128,128,hMemDC,0,0,SRCCOPY
        invoke  InvalidateRect,hWnd,addr rect,0
     
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

end	start